// PSU contorl API header
// Copyright (C) 2007 H.Momose
#ifndef __PSUCONTROL_H__
#define __PSUCONTROL_H__

#include "serial.h"

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define	PSU_SUCCESS				0
#define	PSU_INVALID_COM			1
#define PSU_ERROR_COM			2
#define PSU_INVALID_DEVICE		3
#define PSU_NOT_INITIALIZED		4

#define VSTEP	(double)0.02
#define ASTEP	(double)0.001

struct psustat_st {
	int		source;
	int		output;
	int		ccmode;
	double	voltage;
	double	current;
};

#define SOURCE_USB		0
#define SOURCE_ADAPTER	1
#define SOURCE_NONE		2

#ifdef __cplusplus
extern "C" {
#endif

int psu_init(const char *port);
void psu_fini();
int psu_getVersion(char *version);
int psu_getStatus(struct psustat_st *psustat);
int psu_setLimit(double voltage, double current);
int psu_on();
int psu_off();
int psu_getLimit(double *voltage, double *current);

#ifdef __cplusplus
}
#endif

#endif