// USBPSUAPPDlg.cpp : Cve[V t@C
// Copyright (C) 2007 H.Momose

#include "stdafx.h"
#include "USBPSUAPP.h"
#include "USBPSUAPPDlg.h"
#include "PsuControl.h"
#include "USBPSUConfig.h"
#include "LogFileDialog.h"
#include "USBPSUFirmup.h"
#include <process.h>

#define MAXPOWER_USB		((double)1.5)
#define MAXPOWER_ADAPTER	((double)6.0)
#define MAXVOLTAGE			((double)20)
#define MAXCURRENT			((double)1)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBPSUAPPDlg _CAO

CUSBPSUAPPDlg::CUSBPSUAPPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBPSUAPPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBPSUAPPDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_cvdisp.m_color = RGB(0,127,0);
	m_vdisp.m_color = RGB(0,127, 0);
	
	m_ccdisp.m_color = RGB(127,0,0);
	m_adisp.m_color = RGB(127,0,0);
	
	m_aset = 0;
	m_vset = 0;

	memset(&m_psustat, 0, sizeof(m_psustat));
	bConnected = 0;

	m_logfile = NULL;

	m_logInterval = 1;
	m_logAppend = 0;

}

CUSBPSUAPPDlg::~CUSBPSUAPPDlg()
{
	psu_fini();
	if(m_logfile){
		fclose(m_logfile);
	}
}




void CUSBPSUAPPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBPSUAPPDlg)
	DDX_Control(pDX, IDC_CVMODE, m_cvdisp);
	DDX_Control(pDX, IDC_CCMODE, m_ccdisp);
	DDX_Control(pDX, IDC_PDISP, m_pdisp);
	DDX_Control(pDX, IDC_ADISP, m_adisp);
	DDX_Control(pDX, IDC_VDISP, m_vdisp);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBPSUAPPDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBPSUAPPDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCONNECT, OnConnect)
	ON_BN_CLICKED(IDCONFIG, OnConfig)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN2, OnDeltaposSpin2)
	ON_BN_CLICKED(IDVSET, OnSetVoltage)
	ON_BN_CLICKED(IDASET, OnSetCurrent)
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDLOGGER, OnLogger)
	ON_BN_CLICKED(IDC_VMAIN, OnVmain)
	ON_BN_CLICKED(IDC_AMAIN, OnAmain)
	ON_BN_CLICKED(IDOUTPUT, OnOutput)
	ON_BN_CLICKED(IDLOGGER, OnLogger)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBPSUAPPDlg bZ[W nh

BOOL CUSBPSUAPPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu, strFirmup;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		strFirmup.LoadString(IDS_FIRMUP);
		if (!strAboutMenu.IsEmpty() && !strFirmup.IsEmpty() )
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_FIRMUP, strFirmup);
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	// SpinRg[id)
	CSpinButtonCtrl *spin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1);
	CEdit *edit = (CEdit*)GetDlgItem(IDC_VEDIT);
	SetDlgItemText(IDC_VEDIT, "0");
	spin->SetBuddy(edit);
	spin->SetRange(0, 40);		// 20/0.5 = 40

	// SpinRg[(d)
	spin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2);
	edit = (CEdit*)GetDlgItem(IDC_AEDIT);
	SetDlgItemText(IDC_AEDIT, "0");
	spin->SetBuddy(edit);
	spin->SetRange(0, 40);		// 1.00/0.025 = 40

	// ݒ背WInvalidȏꍇGfBbgRg[wiFɂ̂
	m_brEdit.CreateSolidBrush(RGB( 255, 255, 0));
	m_clrEdit = RGB(0, 0, 0);

	// o͗Ot
	CRect Rect;
	CWnd *w = GetDlgItem(IDC_SCOPE);
	w->GetWindowRect(&Rect);
	ScreenToClient(&Rect);
	CTime from, to;
	from = 0;
	to = m_config.m_PlotSpan;
	m_Plot.SetBXRange(from, to, true);
	m_Plot.SetSerie(0, PS_SOLID, RGB(0,255,0), 0.0, 25.0, "Voltage", 0);
	m_Plot.SetSerie(1, PS_SOLID, RGB(255,0,0), 0.0, 1.25, "Current", 1);
	m_Plot.m_plotBkColor = RGB(0, 0, 0);
	m_Plot.m_gridColor = RGB (0, 127, 0);
	m_Plot.m_ctlBkColor = GetSysColor(COLOR_MENU);
	m_Plot.m_bAutoScrollX=TRUE;
	m_Plot.m_dNoData = -1;
	m_Plot.Create(WS_CHILD|WS_VISIBLE, Rect, this, 12000);
	m_Plot.SetLegend(0, PS_SOLID, RGB(255,0,0), "Voltage");
	m_Plot.SetLegend(1, PS_SOLID, RGB(0,255,0), "Current");	
	canSize=TRUE;

	char buff[256];
	sprintf(buff, "o̗͂(%db)", m_config.m_PlotSpan);
	SetDlgItemText(IDC_HISTORY, buff);

	// |[g
	SetDlgItemText(IDC_DEVPORT, m_config.m_ComPort);

	// ʂ̎XV̂߂̃^C}[
	SetTimer(1, 500, NULL);

	// ON OFFXCb`p̃rbg}bv
	m_bmOn.LoadBitmap(IDB_BITMAPON);
	m_bmOff.LoadBitmap(IDB_BITMAPOFF);

	// łOFFɂĂ
	CButton *button=(CButton*)GetDlgItem(IDOUTPUT);
	button->SetBitmap(m_bmOff);

	SysLogMessage("\tgN܂");

	// Nڑ
	if(m_config.m_ConnectAtStart){
		OnConnect();
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

#define MSG_HOWTO_UPDATE "t@[XVɎsĂXVvŐNł悤AXVvO͎vO\n"\
	"SɓƗĂ܂B̂߁A̎菇ɂXVvONĂB\n\n"\
	"1. foCX炷ׂẴP[uOAp[IZbg邽10bȏu܂B\n"\
	"2. OUTPUTXCb`܂USBP[uڑACV(ΐF)LED_ł܂ŉ܂B\n"\
	"3. _łmFAOK{^āAt@[EFAXVɐiłB"

void CUSBPSUAPPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX){
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else if(nID == IDM_FIRMUP){
		int rc = MessageBox(_T(MSG_HOWTO_UPDATE), _T("foCXt@[EFAXVvŐN"), MB_ICONINFORMATION  | MB_OKCANCEL);
		if(rc == IDOK){
			USBPSUFirmup dlgFirmup;
			strcpy(dlgFirmup.m_ComPort, m_config.m_ComPort);
			dlgFirmup.DoModal();
		}
	} else {
		if(nID == SC_CLOSE){
			SysLogMessage("\tgI܂");
		}
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CUSBPSUAPPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CUSBPSUAPPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//@foCXƐڑEؒfs
void CUSBPSUAPPDlg::OnConnect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char msgbuff[256];

	if(bConnected){
		// ؒf
		bConnected = false;
		psu_fini();
		SetDlgItemText(IDCONNECT, _T("ڑ"));
		SysLogMessage("foCXؒf܂");
	
	} else {
		// ڑ
		char buff[32];

		if(psu_init(m_config.m_ComPort) != PSU_SUCCESS) goto fail;
				
		// ݂̐ݒl[hobNĕ\
		if(psu_getLimit(&m_vset, &m_aset) != PSU_SUCCESS){
			psu_fini();
			goto fail;
		}
		
		sprintf(buff, "%.2f", m_vset);
		SetDlgItemText(IDC_VEDIT, buff);
		
		sprintf(buff, "%.3f", m_aset);
		SetDlgItemText(IDC_AEDIT, buff);

		// ݏԎ擾
		if(psu_getStatus(&m_psustat) != PSU_SUCCESS){
			psu_fini();
			goto fail;
		}
		m_prevOutput = m_psustat.output;
		m_prevSource = m_psustat.source;

		// t@[o[W擾
		if( psu_getVersion(buff) != PSU_SUCCESS){
			psu_fini();
			goto fail;
		}
		sprintf(msgbuff, "foCX %s/FW%s ڑ܂", m_config.m_ComPort, buff);
		SysLogMessage(msgbuff);

		// o͗̃NA
		m_Plot.Reset();

		SetDlgItemText(IDCONNECT, _T("ؒf"));
		CButton *button=(CButton*)GetDlgItem(IDOUTPUT);
		button->EnableWindow(TRUE);
		bConnected = true;
	}
	return;

fail:
	sprintf(msgbuff, "foCX %s ڑł܂", m_config.m_ComPort);
	SysLogMessage(msgbuff);
	MessageBox(msgbuff, "ERROR", MB_OK | MB_ICONERROR);
}


void CUSBPSUAPPDlg::OnOutput() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton *button=(CButton*)GetDlgItem(IDOUTPUT);

	if(m_psustat.output == false){
		psu_on();
		m_psustat.output = true;
		m_prevOutput = true;
		button->SetBitmap(m_bmOn);
		SysLogMessage("o͂ ON ܂");
	} else {
		psu_off();
		m_psustat.output = false;
		m_prevOutput = false;
		button->SetBitmap(m_bmOff);
		SysLogMessage("o͂ OFF ܂");
	}
}


// ݒ_CAOJ
void CUSBPSUAPPDlg::OnConfig() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_config.DoModal();
	
	// |[g
	SetDlgItemText(IDC_DEVPORT, m_config.m_ComPort);
}


BOOL CUSBPSUAPPDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	// dRg[̕
	if(pMsg->message==WM_CHAR && ::GetDlgCtrlID(pMsg->hwnd)==IDC_VEDIT){
		char d=(TCHAR)pMsg->wParam;
		if ( ( d != VK_BACK ) && ( d != '.' ) && ( d < '0' || d > '9' ) ){
			return TRUE;
		}
	}

	// dRg[̕
	if(pMsg->message==WM_CHAR && ::GetDlgCtrlID(pMsg->hwnd)==IDC_AEDIT){
		char d=(TCHAR)pMsg->wParam;
		if ( ( d != VK_BACK ) && ( d != '.' ) && ( d < '0' || d > '9' ) ){
			return TRUE;
		}
	}

	// ESCL[𖳌ɂ
	if(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE){
		return FALSE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}


// dXs0.5VXebv40iK
void CUSBPSUAPPDlg::OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	int val,low,upp;
	char buf[MAX_PATH];
	CSpinButtonCtrl *csb=(CSpinButtonCtrl *)CWnd::FromHandle(pNMUpDown->hdr.hwndFrom);
	CWnd *cwn=csb->GetBuddy();
	csb->GetRange(low,upp);
	if(low>upp)
		val=low,low=upp,upp=val;
	
	cwn->GetWindowText(buf,sizeof(buf));
	val=pNMUpDown->iDelta+(int)(atof(buf)*2);
	
	if(val<low) val=low;
	if(val>upp) val=upp;
	sprintf(buf,"%.2f",((double)val)/2);
	cwn->SetWindowText(buf);

	*pResult = 0;
}


// dXs0.025AXebv40iK
void CUSBPSUAPPDlg::OnDeltaposSpin2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	int val,low,upp;
	char buf[MAX_PATH];
	CSpinButtonCtrl *csb=(CSpinButtonCtrl *)CWnd::FromHandle(pNMUpDown->hdr.hwndFrom);
	CWnd *cwn=csb->GetBuddy();
	csb->GetRange(low,upp);
	if(low>upp)
		val=low,low=upp,upp=val;
	
	cwn->GetWindowText(buf,sizeof(buf));
	val=pNMUpDown->iDelta+(int)(atof(buf)*40);
	
	if(val<low) val=low;
	if(val>upp) val=upp;
	sprintf(buf,"%.3f",((double)val)/40);
	cwn->SetWindowText(buf);

	*pResult = 0;
}


void CUSBPSUAPPDlg::OnSetVoltage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString	string;
	double maxpower;
	char buff[256];

	maxpower = (m_psustat.source == SOURCE_USB) ? MAXPOWER_USB : MAXPOWER_ADAPTER; 
	
	UINT isCheckV = IsDlgButtonChecked(IDC_VMAIN);
	UINT isCheckA = IsDlgButtonChecked(IDC_AMAIN);

	GetDlgItemText(IDC_VEDIT, string);
	m_vset = atof(string);
	if(m_vset > MAXVOLTAGE){
		SysLogMessage("eݒd𒴂邽ߐݒł܂");
		m_vset = -1;	// Invalid
		return;
	}

	GetDlgItemText(IDC_AEDIT, string);
	m_aset = atof(string);
	if(m_aset > MAXCURRENT){
		SysLogMessage("eݒd𒴂邽ߐݒł܂");
		m_aset = -1;	// Invalid
		return;
	}

	m_vset = (int)(m_vset / VSTEP) * VSTEP;
	sprintf(buff, "%.2f", m_vset);
	SetDlgItemText(IDC_VEDIT, buff);

	if(isCheckV){
		m_aset = (double) maxpower / m_vset;
		if(m_aset > MAXCURRENT){
			m_aset = MAXCURRENT;
		}
		m_aset = (int)(m_aset / ASTEP) * ASTEP;
		sprintf(buff, "%.3f", m_aset);
		SetDlgItemText(IDC_AEDIT, buff);
		
	} else if(m_vset * m_aset > maxpower){
		SysLogMessage("ed͗eʂ𒴂邽ߐݒł܂");
		m_vset = -1;
		return;
	}

	//Invalidate(false);
	psu_setLimit( (double)m_vset, (double)m_aset);
	sprintf(buff, "o͂ %.2fV/%.3fA ɃZbg܂", m_vset, m_aset);
	SysLogMessage(buff);
}


void CUSBPSUAPPDlg::OnSetCurrent() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString	string;
	double maxpower;
	char buff[256];

	maxpower = (m_psustat.source == SOURCE_USB) ? MAXPOWER_USB : MAXPOWER_ADAPTER; 

	UINT isCheckV = IsDlgButtonChecked(IDC_VMAIN);
	UINT isCheckA = IsDlgButtonChecked(IDC_AMAIN);

	GetDlgItemText(IDC_AEDIT, string);
	m_aset = atof(string);
	if(m_aset > MAXCURRENT){
		SysLogMessage("eݒd𒴂邽ߐݒł܂");
		m_aset = -1;	// Invalid
		return;
	}

	GetDlgItemText(IDC_VEDIT, string);
	m_vset = atof(string);
	if(m_vset > MAXVOLTAGE){
		SysLogMessage("eݒd𒴂邽ߐݒł܂");
		m_vset = -1;	// Invalid
		return;
	}

	m_aset = (int)(m_aset / ASTEP) * ASTEP;
	sprintf(buff, "%.3f", m_aset);
	SetDlgItemText(IDC_AEDIT, buff);
		
	if(isCheckA){
		m_vset = (double) maxpower / m_aset;
		if(m_vset > MAXVOLTAGE){
			m_vset = MAXVOLTAGE;
		}
		m_vset = (int)(m_vset / VSTEP) * VSTEP;
		sprintf(buff, "%.2f", m_vset);
		SetDlgItemText(IDC_VEDIT, buff);
		
	} else if(m_vset * m_aset > maxpower){
		SysLogMessage("ed͗eʂ𒴂邽ߐݒł܂");
		m_aset = -1;
		return;
	}

	//Invalidate(false);
	psu_setLimit( (double)m_vset, (double)m_aset);
	sprintf(buff, "o͂ %.2fV/%.3fA ɃZbg܂", m_vset, m_aset);
	SysLogMessage(buff);
}


HBRUSH CUSBPSUAPPDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	
	// dݒ͈͂ł΁A{bNX̐FςĒʒm
	if(nCtlColor == CTLCOLOR_EDIT && pWnd->GetDlgCtrlID() == IDC_VEDIT){
		if(m_vset < 0){
			// ȓdݒ
			pDC->SetBkMode(TRANSPARENT);	// wi
			return (HBRUSH) m_brEdit;		// wiFuV
		}
	}

	// dݒ͈͂ł΁A{bNX̐FςĒʒm
	if(nCtlColor == CTLCOLOR_EDIT && pWnd->GetDlgCtrlID() == IDC_AEDIT){
		if(m_aset < 0){
			// ȓdݒ
			pDC->SetBkMode(TRANSPARENT);	// wi
			return (HBRUSH) m_brEdit;		// wiFuV
		}
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}


void CUSBPSUAPPDlg::SysLogMessage(const char *message)
{
	char	buff[4096];
	CTime	ct = CTime::GetCurrentTime();

	// OeLXgGAւ̕\
	sprintf(buff, "[%02d:%02d:%02d] %s\n",
		ct.GetHour(), ct.GetMinute(), ct.GetSecond(),
		message);

	CRichEditCtrl*rec = (CRichEditCtrl *) GetDlgItem(IDC_EDITLOG);
	rec->SendMessage(EM_SETSEL, (WPARAM) -1, (LPARAM) -1);
	rec->SendMessage(EM_REPLACESEL, FALSE, (LPARAM) buff);

	// VXeOt@Cւ̏o
	if(m_config.m_UseSysLogFile){
		FILE *fp = fopen(m_config.m_SysLogFileName, "a");
		if(fp){
			fprintf(fp, "[%02d/%02d/%02d %02d:%02d:%02d] %s\n",
				ct.GetYear() % 100, ct.GetMonth(), ct.GetDay(), ct.GetHour(), ct.GetMinute(), ct.GetSecond(),
				message);
			fclose(fp);
		}
	}
}


void CUSBPSUAPPDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	char buff[256];
	CButton *button;
	
	if(bConnected){
		// foCXڑ		
		button=(CButton*)GetDlgItem(IDVSET);
		button->EnableWindow(TRUE);

		button=(CButton*)GetDlgItem(IDASET);
		button->EnableWindow(TRUE);

		button=(CButton*)GetDlgItem(IDOUTPUT);
		button->EnableWindow(TRUE);

		button=(CButton*)GetDlgItem(IDLOGGER);
		button->EnableWindow(TRUE);

		// ݂̏Ԃ擾	
		if(psu_getStatus(&m_psustat) != PSU_SUCCESS){	
			// ڑꂽ
			bConnected = 0;
			psu_fini();
			SetDlgItemText(IDCONNECT, _T("ڑ"));
			SysLogMessage("foCXƐؒf܂");
			MessageBox("foCXƐؒf܂", "ERROR", MB_OK | MB_ICONERROR);
			goto fini;
		}

		if(m_config.m_OffsetAtt){
			// dItZbg
			// R͖7.8k
			m_psustat.current -= m_psustat.voltage / (double) 7800;
		}

		CEdit *editcv = (CEdit*) GetDlgItem(IDC_CVMODE);
		CEdit *editcc = (CEdit*) GetDlgItem(IDC_CCMODE);
			
		// o̓XCb`\
		if(m_psustat.output){
			// ON
			CButton *button=(CButton*)GetDlgItem(IDOUTPUT);
			//button->SetWindowText("OFF");
			button->SetBitmap(m_bmOn);
			// CV,CC\
			if(m_psustat.ccmode){
				// CC
				editcv->EnableWindow(false);
				editcc->EnableWindow(true);
			} else {
				// CV
				editcv->EnableWindow(true);
				editcc->EnableWindow(false);
			}

		} else {
			// OFF
			CButton *button=(CButton*)GetDlgItem(IDOUTPUT);
			//button->SetWindowText("ON");
			button->SetBitmap(m_bmOff);
			editcv->EnableWindow(false);
			editcc->EnableWindow(false);

		}

		if(m_prevOutput && !m_psustat.output){
			SysLogMessage("o͂OFF܂");
		}
		if(!m_prevOutput && m_psustat.output){
			SysLogMessage("o͂ON܂");
		}
		m_prevOutput = m_psustat.output;

		// ݂̓dl\
		sprintf(buff, "%.2f", m_psustat.voltage);
		SetDlgItemText(IDC_VDISP, buff);

		// ݂̓dl\
		sprintf(buff, "%.3f", m_psustat.current);
		SetDlgItemText(IDC_ADISP, buff);

		// USBzXgdACA_v^d̔fs\ς
		switch(m_psustat.source){

		case SOURCE_USB:
			// zXgd@[^XP[1.5Wɂ
			SetDlgItemText(IDC_METER1, "0.5");
			SetDlgItemText(IDC_METER2, "1.0");
			SetDlgItemText(IDC_METER3, "1.5");
			m_pdisp.SetRange(0, 1500);	// in mWatts

			// USBzXgd\
			SetDlgItemText(IDC_PWRBY, "USBzXgd@őo͓d1.5W");
			break;

		case SOURCE_ADAPTER:
			// A_v^d@[^XP[6.0Wɂ
			SetDlgItemText(IDC_METER1, "2.0");
			SetDlgItemText(IDC_METER2, "4.0");
			SetDlgItemText(IDC_METER3, "6.0");
			m_pdisp.SetRange(0, 6000);	// in mWatts

			// USBzXgd\
			SetDlgItemText(IDC_PWRBY, "ACA_v^d@őo͓d6.0W");
			break;

		case SOURCE_NONE:
		default:
			// A_v^͎hĂ邪dĂȂ
			SetDlgItemText(IDC_METER1, "2.0");
			SetDlgItemText(IDC_METER2, "4.0");
			SetDlgItemText(IDC_METER3, "6.0");
			m_pdisp.SetRange(0, 6000);	// in mWatts
			SetDlgItemText(IDC_PWRBY, "ACA_v^ڑ@d");
		}

		if(m_prevSource != m_psustat.source){
			switch(m_psustat.source){
			case SOURCE_USB:
				SysLogMessage("USBzXgd");
				// A_v^d->USBd̏ꍇAݒ肪NA
				// PȂNAAꉞfoCXݒl[hobN
				if(psu_getLimit(&m_vset, &m_aset) != PSU_SUCCESS){
					// ڑꂽ
					bConnected = 0;
					psu_fini();
					SetDlgItemText(IDCONNECT, _T("ڑ"));
					SysLogMessage("foCXƐؒf܂");
					MessageBox("foCXƐؒf܂", "ERROR", MB_OK | MB_ICONERROR);
					goto fini;
				}
				sprintf(buff, "%.2f", m_vset);
				SetDlgItemText(IDC_VEDIT, buff);
				sprintf(buff, "%.3f", m_aset);
				SetDlgItemText(IDC_AEDIT, buff);
				break;

			case SOURCE_ADAPTER:
				SysLogMessage("A_v^d");
				break;

			case SOURCE_NONE:
				SysLogMessage("A_v^ڑ@d");
			}
			m_prevSource = m_psustat.source;
		}

		// o[[^[̍XV
		m_pdisp.SetPos((int) (m_psustat.voltage * m_psustat.current * (double)1000));
		UpdateData(FALSE);

		// o͗̍XV
		m_Plot.AddPoint(0,  CTime::GetCurrentTime(), m_psustat.voltage);
		m_Plot.AddPoint(1,  CTime::GetCurrentTime(), m_psustat.current);
		Invalidate(false);

		// Oo
		Logger(m_vset, m_aset, m_psustat.voltage, m_psustat.current, m_psustat.ccmode, m_psustat.output);
		
	} else {
		// foCXؒf
		SetDlgItemText(IDC_VDISP, "--.--");
		SetDlgItemText(IDC_ADISP, "-.---");

		m_pdisp.SetPos(0);
		UpdateData(FALSE);

		CButton *button=(CButton*)GetDlgItem(IDVSET);
		button->EnableWindow(FALSE);

		button=(CButton*)GetDlgItem(IDASET);
		button->EnableWindow(FALSE);

		button=(CButton*)GetDlgItem(IDOUTPUT);
		button->EnableWindow(FALSE);

		if(m_logfile){
			fclose(m_logfile);
			m_logfile = NULL;
			SetDlgItemText(IDLOGGER, "Jn");
		}

		button=(CButton*)GetDlgItem(IDLOGGER);
		button->EnableWindow(FALSE);
	}

fini:
	CDialog::OnTimer(nIDEvent);
}


void CUSBPSUAPPDlg::OnLogger() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	if(m_logfile){
		// O~
		fclose(m_logfile);
		m_logfile = NULL;
		SysLogMessage("O~܂");
		SetDlgItemText(IDLOGGER, "Jn");
	} else {
		// OJn
		
		// OL^pJX^_CAO쐬
		LogFileDialog mfd(
			FALSE,
			NULL,
			NULL,
			OFN_FILEMUSTEXIST | OFN_EXPLORER | OFN_ENABLETEMPLATE | OFN_ENABLEHOOK,
			_T("CSV(*.csv)|*.csv|S(*.*)|*.*||") );

		mfd.m_ofn.lpTemplateName = MAKEINTRESOURCE(IDD_MYFILE);
		mfd.m_interval = m_logInterval;
		mfd.m_append = m_logAppend;

		if( mfd.DoModal() == IDOK){
			m_logInterval = mfd.m_interval;
			m_logAppend = mfd.m_append;

			CString fileName;
			fileName = mfd.GetPathName();
			const char *f = LPCTSTR(fileName);
			m_logfile = fopen(f, m_logAppend ? "a" : "w");
			if(!m_logfile){
				SysLogMessage("Ot@CI[vł܂");
			} else {
				SysLogMessage("OJn܂");
				SetDlgItemText(IDLOGGER, "~");
			}
		}
	}	
}


// CSV`OL^
void CUSBPSUAPPDlg::Logger(double vset, double aset, double vnow, double anow, int ccmode, int output)
{
	static time_t prev;
	if(!m_logfile) return;

	char	buff[1024];
	CTime	ct = CTime::GetCurrentTime();

	if(prev + m_logInterval >  ct.GetTime() ) return;

	prev = ct.GetTime();

	sprintf(buff, "%02d/%02d/%02d %02d:%02d:%02d,%.2f,%.3f,%s,%.2f,%.3f\n",
		ct.GetYear() % 100, ct.GetMonth(), ct.GetDay(),
		ct.GetHour(), ct.GetMinute(), ct.GetSecond(),
		vset, aset,
		output ? ccmode ? "CC" : "CV" : "OFF", vnow, anow);

	fputs(buff, m_logfile);
	fflush(m_logfile);
}


void CUSBPSUAPPDlg::OnVmain() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UINT	isCheckA;
	
	isCheckA = IsDlgButtonChecked(IDC_AMAIN);
	if(isCheckA){
		CheckDlgButton(IDC_AMAIN, 0);
	}
}


void CUSBPSUAPPDlg::OnAmain() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UINT	isCheckV;
	
	isCheckV = IsDlgButtonChecked(IDC_VMAIN);
	if(isCheckV){
		CheckDlgButton(IDC_VMAIN, 0);
	}
}


BOOL CUSBPSUAPPDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	return FALSE;

	//return CDialog::OnHelpInfo(pHelpInfo);
}
