// Serial control
// Copyright (C) 2007 H.Momose
// ChangeLog
//    Ver 1.0.1.0	t@[EFAXVvÕCv̂߁AʂɎgp֐
//					PsuControl.cڐ݂B

#include <stdio.h>
#include <windows.h>
#include "serial.h"
#include "comutil.h"

/*****************************************************************************
 * Function : comm_open
 * Argument : port  <=  VA|[g  (ex. "com1")
 *			: baud  <=	VAXs[h (ex. 9600)
 * Return   : not NULL	: @nh߂ 
 *			: NULL		: s
 * Remarks  : 
 *****************************************************************************/
commio_t *comm_open(const char *port, int baud)
{
    DCB			dcb;
    commio_t	*io;
	char		buff[32];

	// m
	io = malloc(sizeof(commio_t));
	if(!io){
		goto fail;
	}
	memset(io, 0, sizeof(commio_t));

	// |[gI[v
	sprintf(buff, "\\\\.\\%s", port);
    io->h_comm = CreateFile(buff, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
    if(io->h_comm == INVALID_HANDLE_VALUE){
		goto fail;
    }

	// VAݒ
    EscapeCommFunction(io->h_comm, CLRDTR);
	GetCommState(io->h_comm, &dcb);
	// BuildCommDCB("9600,n,8,1", &dcb);
	dcb.BaudRate = baud;
	dcb.fParity = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.ByteSize = 8;
	SetCommState(io->h_comm, &dcb);
	EscapeCommFunction(io->h_comm, SETDTR);

	SetCommMask(io->h_comm, EV_RXCHAR);

	// 񓯊I/OCxgnh쐬
	io->os_r.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!io->os_r.hEvent){
		goto fail;
	}
	io->os_r.Offset = 0;
	io->os_r.OffsetHigh = 0;

	io->os_w.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
	if(!io->os_w.hEvent){
		goto fail;
	}
	io->os_w.Offset = 0;
	io->os_w.OffsetHigh = 0;

	return(io);

fail:
	if(io->os_w.hEvent){
		CloseHandle(io->os_w.hEvent);
	}

	if(io->os_r.hEvent){
		CloseHandle(io->os_r.hEvent);
	}

	if(io->h_comm){
		CloseHandle(io->h_comm);
	}

	if(io){
		free(io);
	}

	return(NULL);
}


/*****************************************************************************
 * Function : comm_close
 * Argument : io <= nh
 * Return   : none
 * Remarks  : 
 *****************************************************************************/
void comm_close(commio_t *io)
{
	if(io){
		CloseHandle(io->os_w.hEvent);
		CloseHandle(io->os_r.hEvent);
		CloseHandle(io->h_comm);
		free(io);
	}
}


/*****************************************************************************
 * Function : comm_write
 * Argument : io <= nh
 *			: buff <= of[^
 *			: buff_len <= of[^
 * Return   : -1 : failed
 *			: LȊO : of[^
 * Remarks  : 
 *****************************************************************************/
int comm_write(commio_t *io, char *buff, int buff_len)
{
	int		n_written = 0;

	ResetEvent(io->os_w.hEvent);
	if(WriteFile(io->h_comm, buff, buff_len, &n_written,  &io->os_w)){
		// 񓯊I/Ô߁AŖ߂邱Ƃ͂܂Ǝv
		return(n_written);
	}

	if(GetLastError() != ERROR_IO_PENDING){
		return(-1);
	}

	// I/O pending̎AWriteFileɗ^obt@ύXANAƗ̂Ŋ𓯊
	switch(WaitForSingleObject(io->os_w.hEvent, 1000)){
	
	case WAIT_OBJECT_0:
		if(GetOverlappedResult(io->h_comm, &io->os_w, &n_written, FALSE)){
			// 
			return(n_written);
		}
		return(-1);

	case WAIT_TIMEOUT:
	default:
		break;
	}
	
	return (-1);
}


/*****************************************************************************
 * Function : comm_read
 * Argument : io <= nh
 *			: buff => Mobt@
 *			: buff_size <= Mobt@e
 * Return   : -1 : s
 *			:  0 : Mf[^A邢̓^CAEg
 *			: LȊO : Mf[^
 * Remarks  : !HasOverlappedIOCompleted()̏ꍇreturn 0łȂAM҂
 *			: s悤ɕύX
 *****************************************************************************/
int comm_read(commio_t *io, char *buff, int buff_size)
{
	DWORD	errorFlags;
	COMSTAT	comstat;
	DWORD	dwEvtMask = 0;
	int		length, n_read=0;

	if(!HasOverlappedIoCompleted(&io->os_r)){
		goto	retry;
	}

   	ClearCommError(io->h_comm, &errorFlags, &comstat);
	length = min((unsigned int)buff_size, comstat.cbInQue);
	
	while(length == 0){
		ResetEvent(io->os_r.hEvent);
		if(WaitCommEvent(io->h_comm, &dwEvtMask, &io->os_r)){
			ClearCommError(io->h_comm, &errorFlags, &comstat);
			length = min((unsigned int)buff_size, comstat.cbInQue);
			break;
		}

		if(GetLastError() != ERROR_IO_PENDING){
			return(-1);
		}

retry:
		switch(WaitForSingleObject(io->os_r.hEvent, 100)){

		case WAIT_OBJECT_0:
			if(ClearCommError(io->h_comm, &errorFlags, &comstat)){
				length = comstat.cbInQue;
				break;
			}
			return(-1);

		case WAIT_TIMEOUT:
			return (0);

		default:
			return(-1);
		}
	}

	if(ReadFile(io->h_comm, buff, length, &n_read, &io->os_r)){
		return(n_read);	
	}

	return(-1);
}


/*****************************************************************************
 * Function : comm_setline
 * Argument : io <= nh
 *			: buff <= Mf[^
 *			: buff_len <= Mf[^̒
 *			: interval <= 1閈̎ԊԊu
 * Return	: -1 : s
 *			: others: Mf[^
 * Remarks  : foCXɃt[AMobt@߁AintervalɑM
 *****************************************************************************/
int comm_setline(commio_t *io, char *buff, int buff_len, int interval)
{
	int i;
	
	Sleep(interval);
	for(i =0; i < buff_len; i++){
		if(comm_write(io, buff +i, 1) != 1){
			return(-1);
		}
		Sleep(interval);
	}
	return(i);
}


/*****************************************************************************
 * Function : comm_getline
 * Argument : io <= nh
 *			: buff => Mf[^
 *			: buff_size <= Mobt@TCY
 * Return	: -1 : s
 *			: 0  : ^CAEg
 *			: others: Mf[^
 * Remarks  : \r\n܂ŎM
 *****************************************************************************/
int comm_getline(commio_t *io, char *buff, int buff_size)
{
	int i, len, buff_len = 0;

	for(i =0; i < 5; i++){
		// 5񃊃gC

		len = comm_read(io, buff + buff_len, buff_size - buff_len -1);
		if(len < 0){
			return(len);
		}
		if(len == 0){
			continue;
		}

		buff_len += len;
		buff[buff_len] = 0;
		if(strstr(buff, "\r\n")){
			// \r\n̂OK
			break;
		}
	}

	return(buff_len);
}
