// Serialcontrol header
// Copyright (C) 2007 H.Momose
#ifndef __SERIAL_H__
#define __SERIAL_H__

#include <windows.h>

typedef struct {
	HANDLE			h_comm;			// Comm io handle
	OVERLAPPED		os_r, os_w;		// Asyncronous I/O handle
} commio_t;

#ifdef __cplusplus
extern "C" {
#endif

// Function prototypes
commio_t *comm_open(const char *port, int baud);
void comm_close(commio_t *io);
int comm_write(commio_t *io, char *buff, int len);
int comm_read(commio_t *io, char *buff, int size);
int comm_setline(commio_t *io, char *buff, int buff_len, int interval);
int comm_getline(commio_t *io, char *buff, int buff_size);
int hex2int(char c);
char int2hex(int i);

#ifdef __cplusplus
}
#endif

#endif